TagLib::RIFF::WAV::File Class Reference

An implementation of TagLib::File with WAV specific methods. More...

`#include <wavfile.h>`

Inheritance diagram for TagLib::RIFF::WAV::File:
[legend]
Collaboration diagram for TagLib::RIFF::WAV::File:
[legend]

## Public Types

enum | TagTypes { NoTags = 0x0000 , ID3v2 = 0x0001 , Info = 0x0002 , AllTags = 0xffff }
Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }

## Public Member Functions

| File (FileName file, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average, ID3v2::FrameFactory *frameFactory=nullptr)
| File (IOStream *stream, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average, ID3v2::FrameFactory *frameFactory=nullptr)
| ~File () override
| File (const File &)=delete
File & | operator= (const File &)=delete
TagLib::Tag * | tag () const override
ID3v2::Tag * | ID3v2Tag () const
Info::Tag * | InfoTag () const
void | strip (TagTypes tags=AllTags)
PropertyMap | properties () const override
void | removeUnsupportedProperties (const StringList &unsupported) override
PropertyMap | setProperties (const PropertyMap &) override
Properties * | audioProperties () const override
bool | save () override
bool | save (TagTypes tags, StripTags strip=StripOthers, ID3v2::Version version=ID3v2::v4)
bool | hasID3v2Tag () const
bool | hasInfoTag () const
Public Member Functions inherited from TagLib::RIFF::File
| File (const File &)=delete
File & | operator= (const File &)=delete
Public Member Functions inherited from TagLib::File
| File (const File &)=delete
File & | operator= (const File &)=delete
FileName | name () const
virtual StringList | complexPropertyKeys () const
virtual List< VariantMap > | complexProperties (const String &key) const
virtual bool | setComplexProperties (const String &key, const List< VariantMap > &value)
ByteVector | readBlock (size_t length)
void | writeBlock (const ByteVector &data)
offset_t | find (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
offset_t | rfind (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, offset_t start=0, size_t replace=0)
void | removeBlock (offset_t start=0, size_t length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (offset_t offset, Position p=Beginning)
void | clear ()
offset_t | tell () const
offset_t | length ()

## Static Public Member Functions

static bool | isSupported (IOStream *stream)

## Friends

class | Properties

## Additional Inherited Members

Protected Types inherited from TagLib::RIFF::File
enum | Endianness { BigEndian , LittleEndian }
Protected Member Functions inherited from TagLib::RIFF::File
| File (FileName file, Endianness endianness)
| File (IOStream *stream, Endianness endianness)
unsigned int | riffSize () const
unsigned int | chunkCount () const
offset_t | chunkOffset (unsigned int i) const
unsigned int | chunkDataSize (unsigned int i) const
unsigned int | chunkPadding (unsigned int i) const
ByteVector | chunkName (unsigned int i) const
ByteVector | chunkData (unsigned int i)
void | setChunkData (unsigned int i, const ByteVector &data)
void | setChunkData (const ByteVector &name, const ByteVector &data)
void | setChunkData (const ByteVector &name, const ByteVector &data, bool alwaysCreate)
void | removeChunk (unsigned int i)
void | removeChunk (const ByteVector &name)
Protected Member Functions inherited from TagLib::File
| File (FileName fileName)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (offset_t length)
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

An implementation of TagLib::File with WAV specific methods.

This implements and provides an interface for WAV files to the TagLib::Tag and TagLib::AudioProperties interfaces by way of implementing the abstract TagLib::File API as well as providing some additional information specific to WAV files.

## Member Enumeration Documentation

## TagTypes

enum TagLib::RIFF::WAV::File::TagTypes

Enumerator
NoTags | Empty set. Matches no tag types.
ID3v2 | Matches ID3v2 tags.
Info | Matches INFO tags.
AllTags | Matches all tag types.

## Constructor & Destructor Documentation

## File() [1/3]

TagLib::RIFF::WAV::File::File | ( | FileName | file,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | propertiesStyle = Properties::Average,
|  | ID3v2::FrameFactory * | frameFactory = nullptr )

Constructs a WAV file from file. If readProperties is `true` the file's audio properties will also be read.

Note
  In the current implementation, propertiesStyle is ignored.

If this file contains an ID3v2 tag, the frames will be created using frameFactory (default if null).

References TagLib::AudioProperties::Average.

Referenced by File(), and operator=().

## File() [2/3]

TagLib::RIFF::WAV::File::File | ( | IOStream * | stream,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | propertiesStyle = Properties::Average,
|  | ID3v2::FrameFactory * | frameFactory = nullptr )

Constructs a WAV file from stream. If readProperties is `true` the file's audio properties will also be read.

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.
  In the current implementation, propertiesStyle is ignored.

If this file contains an ID3v2 tag, the frames will be created using frameFactory (default if null).

References TagLib::AudioProperties::Average.

## ~File()

TagLib::RIFF::WAV::File::~File | ( |  | ) |

override virtual

Destroys this instance of the File.

Reimplemented from TagLib::RIFF::File.

## File() [3/3]

TagLib::RIFF::WAV::File::File | ( | const File & |  | ) |

delete

References File().

## Member Function Documentation

## audioProperties()

Properties * TagLib::RIFF::WAV::File::audioProperties | ( |  | ) | const

override virtual

Returns the WAV::Properties for this file. If no audio properties were read then this will return a null pointer.

Implements TagLib::File.

References Properties.

## hasID3v2Tag()

bool TagLib::RIFF::WAV::File::hasID3v2Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an ID3v2 tag.

See also
  ID3v2Tag()

## hasInfoTag()

bool TagLib::RIFF::WAV::File::hasInfoTag | ( |  | ) | const

Returns whether or not the file on disk actually has a RIFF INFO tag.

See also
  InfoTag()

## ID3v2Tag()

ID3v2::Tag * TagLib::RIFF::WAV::File::ID3v2Tag | ( |  | ) | const

Returns the ID3v2 Tag for this file.

Note
  This always returns a valid pointer regardless of whether or not the file on disk has an ID3v2 tag. Use hasID3v2Tag() to check if the file on disk actually has an ID3v2 tag.

See also
  hasID3v2Tag()

## InfoTag()

Info::Tag * TagLib::RIFF::WAV::File::InfoTag | ( |  | ) | const

Returns the RIFF INFO Tag for this file.

Note
  This always returns a valid pointer regardless of whether or not the file on disk has a RIFF INFO tag. Use hasInfoTag() to check if the file on disk actually has a RIFF INFO tag.

See also
  hasInfoTag()

## isSupported()

bool TagLib::RIFF::WAV::File::isSupported | ( | IOStream * | stream | ) |

static

Returns whether or not the given stream can be opened as a WAV file.

Note
  This method is designed to do a quick check. The result may not necessarily be correct.

## operator=()

File & TagLib::RIFF::WAV::File::operator= | ( | const File & |  | ) |

delete

References File().

## properties()

PropertyMap TagLib::RIFF::WAV::File::properties | ( |  | ) | const

override virtual

Implements the unified property interface – export function. This method forwards to ID3v2::Tag::properties().

Reimplemented from TagLib::File.

## removeUnsupportedProperties()

void TagLib::RIFF::WAV::File::removeUnsupportedProperties | ( | const StringList & | properties | ) |

override virtual

Removes unsupported properties, or a subset of them, from the file's metadata. The parameter properties must contain only entries from properties().unsupportedData().

Reimplemented from TagLib::File.

## save() [1/2]

bool TagLib::RIFF::WAV::File::save | ( |  | ) |

override virtual

Saves the file.

Implements TagLib::File.

## save() [2/2]

bool TagLib::RIFF::WAV::File::save | ( | TagTypes | tags,
|  | StripTags | strip = StripOthers,
|  | ID3v2::Version | version = ID3v2::v4 )

Save the file. If strip is specified, it is possible to choose if tags not specified in tags should be stripped from the file or retained. With version, it is possible to specify whether ID3v2.4 or ID3v2.3 should be used.

References strip(), TagLib::File::StripOthers, and TagLib::ID3v2::v4.

## setProperties()

PropertyMap TagLib::RIFF::WAV::File::setProperties | ( | const PropertyMap & |  | ) |

override virtual

Implements the unified property interface – import function. This method forwards to ID3v2::Tag::setProperties().

Reimplemented from TagLib::File.

## strip()

void TagLib::RIFF::WAV::File::strip | ( | TagTypes | tags = AllTags | ) |

This will strip the tags that match the OR-ed together TagTypes from the file. By default it strips all tags. It returns `true` if the tags are successfully stripped.

Note
  This will update the file immediately.

References AllTags.

Referenced by save().

## tag()

TagLib::Tag * TagLib::RIFF::WAV::File::tag | ( |  | ) | const

override virtual

Returns the tag for this file. This will be a RIFF INFO tag, an ID3v2 tag or a combination of the two.

Implements TagLib::File.

## Friends And Related Symbol Documentation

## Properties

friend class Properties

friend

References Properties, and TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

Referenced by audioProperties(), and Properties.

The documentation for this class was generated from the following file:

- wavfile.h